Subject: Re: Lock-up on PPC64

From: Michael Ellerman <[email-masked]>
Date: Mon, 05 Jan 2009 23:28:36 +1100

On Sun, 2008-12-28 at 03:45 +0300, malc wrote:
> On Thu, 25 Dec 2008, Benjamin Herrenschmidt wrote:
> 
> > On Wed, 2008-12-24 at 03:08 +0300, [email-masked] wrote:
> >> Ken Moffat <[email-masked]> writes:
> >>
> >>> On Tue, Dec 23, 2008 at 06:04:45AM +0300, [email-masked] wrote:
> 
> [..snip..]
> 
> >>
> >> Thanks for the reference, but i'm sure, now more than ever, that bad
> >> memory has nothing to do with it, all signs are there that kernel is
> >> confused by the way signals are (mis)used by Mono.
> >
> > It shouldn't be but I agree with you, it smells bad. Can you report that
> > again on the [email-masked] mailing list ? Along with
> > instructions to d/l, install & run the minimum repro-case ? I'll try to
> > give it a go on different ppc64 machines as soon as I'm over my upcoming
> > xmas hangover :-) If it appears to be ps3 specific, we can work with
> > Geoff Levand (PS3 maintainer for Sony) to try to identify the root cause
> > and fix it.
> 
> I've posted a message to linuxppc-dev via gmane, but AFAICS it never made
> it there. Anyhow, here's another try:
> 
> Mono can be obtained from:
> http://ftp.novell.com/pub/mono/sources/mono/mono-2.0.1.tar.bz2
> 
> Although 2.0.1 only supports ppc32 the problem is still reproducible.
> 
> Now to the Christmas cheer, i've tried v2.6.28 and couldn't help but
> notice that the problem is gone, bisecting v2.6.27 (which funnily i
> had to mark good) to v2.6.28 (which has to be marked bad) wasn't fun
> but eventually converged at ab598b6680f1e74c267d1547ee352f3e1e530f89
> 
> commit ab598b6680f1e74c267d1547ee352f3e1e530f89
> Author: Paul Mackerras <[email-masked]>
> Date:   Sun Nov 30 11:49:45 2008 +0000
> 
>      powerpc: Fix system calls on Cell entered with XER.SO=1
> 
> Now the lock-up is gone, however the code never exercises the path
> taken during the lock-up so i guess it, at least, deserves a better
> look by PPC64 care takers.

I'm confused. Which code never exercises which path, and so what
deserves a better look?

AFAICT this fix will help you, and could explain your problem. You're on
Cell, so you're using the mftb workaround, and ps3_defconfig has
CONFIG_VIRT_CPU_ACCOUNTING=y.

cheers

-- 
Michael Ellerman
OzLabs, IBM Australia Development Lab

wwweb: http://michael.ellerman.id.au
phone: +61 2 6212 1183 (tie line 70 21183)

We do not inherit the earth from our ancestors,
we borrow it from our children. - S.M.A.R.T Person